﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace DoubleDeckerBus
{
    public class EntityBus
    {
        public int Speed { get; private set; }
        public float Weight { get; private set; }
        public Color BodyColor { get;  set; }
        public float Step => Speed * 100 / Weight;
        public EntityBus(int speed, float weight, Color bodyColor)
        {
            Random rnd = new Random();
            Speed = (speed <= 0) ? rnd.Next(50, 150) : speed;
            Weight = (weight <= 0) ? rnd.Next(50, 70) : weight;
            BodyColor = bodyColor;
        }

        public static EntityBus Creator(string data) {
            string[] strs = data.Split(':');
            return new EntityBus(Convert.ToInt32(strs[0]),
                Convert.ToInt32(strs[1]), Color.FromName(strs[2]));
        }
    }
}
