﻿namespace DoubleDeckerBus
{
    internal static class ExtentionBus
    {
        private static readonly char _separatorForObject = ':';
            public static DrawingBus CreateDrawningCar(this string info)
            {
                string[] strs = info.Split(_separatorForObject);
                if (strs.Length == 3)
                {
                    return new DrawingBus(Convert.ToInt32(strs[0]),
                        Convert.ToInt32(strs[1]), Color.FromName(strs[2]));
                }
                if (strs.Length == 6)
                {
                    return new DrawingDDB(Convert.ToInt32(strs[0]),
                        Convert.ToInt32(strs[1]), Color.FromName(strs[2]),
                        Color.FromName(strs[3]), Convert.ToBoolean(strs[4]),
                        Convert.ToBoolean(strs[5]));
                }
                return null;
            }
       
        public static string GetDataForSave(this DrawingBus drawingBus)
        {
            var bus = drawingBus.Bus;
            var str = $"{bus.Speed}{_separatorForObject}{bus.Weight}{_separatorForObject}{bus.BodyColor.Name}";
            if (bus is not EntityDDB sportCar)
            {
                return str;
            }
            return $"{str}{_separatorForObject}{sportCar.ExtraColor.Name}{_separatorForObject}{sportCar.SecondStage}{_separatorForObject}{sportCar.Ledder}";
        }
    }
}